﻿using ProjectPublishing.Entities.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectPublishing.Entities
{
    public class Order
    {
        public int Id { get; private set; }
        public DateTime OrderDate { get; private set; }

        public string Description { get; private set; }

        public ProductType ProductType { get; private set; }

        public int Amount { get; private set; }

        public OrderStatus Status { get; private set; }

        public int CustomerId { get; private set; }

        public int PrintingId { get; private set; }

        public List<OrderMaterials> Materials { get; private set; }

        public static Order CreateOrder(int id, string description, ProductType productType, int amount, OrderStatus status, int customerId, int printingId, List<OrderMaterials> materials)
        {
            return new Order { ProductType = productType, Id = id, Amount = amount, Status = status, CustomerId = customerId, PrintingId = printingId, Materials = materials, OrderDate = DateTime.Now, Description = description ?? string.Empty };
        }
    }
}
